/* ReDMS by Shawn McNeece aka Powerslave for DMS v1.11           */
/* $VER: DMS Converter v1.3 Wed 28-Nov-93 16:40:00               */
/* ReDMS Updated by Mike Steele aka Dragon Slayer for DMS v1.53+ */
/* Thanks to Dave McMillian aka Mac for bug testing              */

parse arg cliargs
pathf = word(cliargs,1)
fn = word(cliargs,2)
path = left(pathf,length(pathf)-length(fn)-4)
rez = "pipe:"||fn

cmstr = "run dms >"||rez" view "||pathf
address command cmstr
address command 'wait'
rc = OPEN(res,rez,'R')
if rc < 1 then do                
   say 'Error, No Results Created.'
   close(res);
   exit
end
i=0
do until eof(res)
   i=i+1;ln.i = READLN(res)
end
close(res)               
   ver  = word(ln.15,5)
   size = word(ln.8,3)
if ver = "1.11" then do;tstwrd=word(ln.17,4);end
   else do;tstwrd=word(ln.18,4);end
Say 'Analyzing DMS v'ver' File: '||pathf||'...'
say 'Compression Used:' tstwrd 'Size:' size
if tstwrd ~="HEAVY1" & tstwrd ~="HEAVY2" & tstwrd ~="DEEP" then do
   say 'Converting '||fn||'.dms to better compression mode'
   cstr="dms repack "pathf" to "path||fn||"tmp.dms cmode best"
   address command cstr
   cmstr="run dms >"||rez" view "||path||fn||"tmp.dms"
   address command cmstr
   rc = OPEN(res,rez,'R')
   if rc < 1 then do
      say 'Error, No Results Created.'
      close(res);
   end
   i=0
   do until eof(res)
      i=i+1;ln.i = READLN(res)
   end
 close(res)
 size2 = word(ln.8,3)
if word(ln.14,5) = "1.11" then tstwrd2=word(ln.17,4)
 else tstwrd2=word(ln.18,4) 
 if size <=0 then size = size2+1
 savings=size-size2
 say 'Filename:      ' pathf
 say 'Original CMODE:' tstwrd 
 say 'New CMODE:     ' tstwrd2
 say 'Original size: ' size 
 say 'Converted size:' size2
   if savings >=1 & size2 ~=0 then do
      cstr="delete "pathf
        address command cstr
           cstr="rename "||path||fn||"tmp.dms "||path||fn||".dms"
           address command cstr
         say "Byte Savings="savings 
       pct=left(size2 / size,4)*100
     say "Percentage gained=" 100-pct
   end
  else do
       cstr="delete "||path||fn||".dms"
       address command cstr
  end
end
say 'Done'
exit(0)
